"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mayStoreLongTaskIdForProfilerCorrelation = mayStoreLongTaskIdForProfilerCorrelation;
const longTaskRegistry_1 = require("./utils/longTaskRegistry");
/**
 * Store the Long Task ID in the registry for the Profiler to link it with the corresponding Profile.
 *
 * @param rawRumEvent The Raw RUM event
 * @param startTime The start time of the event (in this case the Long Task Performance Entry start time)
 */
function mayStoreLongTaskIdForProfilerCorrelation({ rawRumEvent, startTime, }) {
    if (rawRumEvent.type !== "long_task" /* RumEventType.LONG_TASK */) {
        return;
    }
    const longTaskId = rawRumEvent.long_task.id;
    // Store longTaskId in the registry for the Profiler to link it with the corresponding Profile.
    (0, longTaskRegistry_1.setLongTaskId)(longTaskId, startTime);
}
//# sourceMappingURL=profilingCorrelation.js.map