import type { RelativeTime } from '@datadog/browser-core';
type PerformanceEntryStartTime = RelativeTime;
export declare function disableLongTaskRegistry(): void;
/**
 * Store the long task ID in the registry for the Profiler to link it with the corresponding Profile.
 */
export declare function setLongTaskId(longTaskId: string, startTime: PerformanceEntryStartTime): void;
export declare function getLongTaskId(startTime: PerformanceEntryStartTime): string | undefined;
/**
 * Delete the Long Task from the registry once we have collected it.
 *
 * @param collectionRelativeTime The relative time of the collection
 */
export declare function cleanupLongTaskRegistryAfterCollection(collectionRelativeTime: RelativeTime): void;
export {};
