import type { RumConfiguration } from '@datadog/browser-rum-core';
import type { BrowserIncrementalSnapshotRecord } from '../../../types';
import type { ShadowRootsController } from '../shadowRootsController';
import type { Tracker } from './tracker.types';
export type MutationCallBack = (incrementalSnapshotRecord: BrowserIncrementalSnapshotRecord) => void;
export type MutationTracker = Tracker & {
    flush: () => void;
};
/**
 * Buffers and aggregate mutations generated by a MutationObserver into MutationPayload
 */
export declare function trackMutation(mutationCallback: MutationCallBack, configuration: RumConfiguration, shadowRootsController: ShadowRootsController, target: Node): MutationTracker;
export declare function sortAddedAndMovedNodes(nodes: Node[]): void;
